// JavaScript Document
var tabCount = 0;
var currentTab = 1;
var debugMode = false;
var currentModule = 0;
var currentLoadfactor = 0;
var maxLoadfactor = 0;
var maxCablelength = 3500;
var maxModules = 18;
var cabletype = 05;
var maxNoGT = 4;

var modules = window.modules;
var cntmodules = window.cntmodule;

var devices = window.devices;
var cntdevice = window.cntdevice;

var maxLoadFactors = window.maxLoadFactors;
var cntLoadFactors = window.cntLoadFactors;

var operatorpanel = {};
operatorpanel["standbycurrent"] = 323;
operatorpanel["alarmcurrent"] = 370;
operatorpanel["heatemission"] = 2500;

var configuration = [];
var cntconfiguration = 0;
for (cntconfiguration = 0; cntconfiguration < maxModules; cntconfiguration++) {
	configuration[cntconfiguration] = {};
	configuration[cntconfiguration]["moduleid"] = -1;
	configuration[cntconfiguration]["cablelength"] = 0;
	configuration[cntconfiguration]["alarmarea"] = 0;
	configuration[cntconfiguration]["loadfactor"] = -1;
	configuration[cntconfiguration]["additionalloadfactor"] = 0;
	configuration[cntconfiguration]["editable"] = true;
	configuration[cntconfiguration]["secondmoduleid"] = -1;
	configuration[cntconfiguration]["devicenonautomatic"] = 0;
	configuration[cntconfiguration]["deviceautomatic"] = 0;

	configuration[cntconfiguration]["devices"] = [];

	for (i = 0; i < cntdevice; i++) {
		configuration[cntconfiguration]["devices"][i] = 0;
	}
}

var lang = window.location.hash.replace("#", "");
var userLang = (navigator.language || navigator.userLanguage).substring(0, 2).toLowerCase();

if (isEmpty(lang) && lang !== "de" && lang !== "en") {
	if (userLang === 'de') {
		lang = 'de';
	} else {
		lang = "en";
	}
}

setTitle();

function setLang(l) {
	window.location.hash = l;
	window.location.reload();
}

function setTitle() {
	document.title = window.translations[12][lang]
}

function toggleUbext() {
	if ($('#ubextavailable').attr("checked")) {
		$('#ubextbox').fadeIn();
	} else {
		$('#ubextbox').fadeOut();
		$('#ubextstandby').attr('value', '0');
		$('#ubextalarm').attr('value', '0');
	}
}

function checkmax(elem, low, high, exit) {
	if (isEmpty(elem.value)) {
		elem.value = 0;
	} else {
		if (isNaN(elem.value)) {
			elem.value = low;
			alert(window.translations[76][window.lang]);
		} else {
			if (exit == true) {
				val = elem.value;
				elem.value = val.replace(",", ".");
				elem.value = parseFloat(elem.value);
			}

			if (elem.value < low || elem.value > high) {
				if (elem.value < low) {
					elem.value = low;
				}
				if (elem.value > high) {
					elem.value = high;
				}
				alert(window.translations[77][window.lang] + low + window.translations[78][window.lang] + high + window.translations[79][window.lang]);
			}
		}
	}
}

function resetTotals() {

}

function updateCurrentCalculation() {
	var totalStandby = operatorpanel["standbycurrent"]; //BoxDefaultCurrent
	var totalAlarm = operatorpanel["alarmcurrent"]; //BoxDefaultCurrent

	for (i = 0; i < cntconfiguration; i++) {
		if (configuration[i]["editable"] == true) {
			var moduleId = configuration[i]['moduleid'];
			if (moduleId != -1) {
				totalStandby += parseInt(modules[moduleId]["standbycurrent"]);
				totalAlarm += parseInt(modules[moduleId]["standbycurrent"]);

				var lf = 0;
				if (configuration[i]["loadfactor"] > -1 && configuration[i]["alarmarea"] == "yes") {
					lf = ((parseInt(modules[moduleId]["alarmcurrent"]) - parseInt(modules[moduleId]["standbycurrent"])) / 96) * configuration[i]["loadfactor"];
				}
				totalAlarm += lf;
			}
		}
	}
	//alert("Standby: "+totalStandby+"\nAlarm: "+totalAlarm);
	//Rounding added for less accuracy
	totalStandby = ampereRound(totalStandby);
	totalAlarm = ampereRound(totalAlarm);
	//---
	debug("Standby: " + totalStandby + "\nAlarm: " + totalAlarm);
	$('#standbycurrent').attr("value", totalStandby);
	$('#alarmcurrent').attr("value", totalAlarm);
}

function debug(text) {
	if (debugMode == true) {
		alert(text);
	}
}

function toggleHelp() {
	for (i = 0; i <= tabCount; i++) {
		$('#help #part' + i).hide();
	}
	$('#help #part' + currentTab).show();
	$('#help').fadeToggle('slow');
}

function tabInit() {
	tabCount = $('.tab').length;
	debug("count:" + tabCount + "\n current:" + currentTab);
	$('#btn-next').show();
	$('#btn-back').show();
	$('#printBtn').hide();
	$('#printBtnLine').hide();
	//$('#printAcceptance').hide();
	$('.tab').hide();
	$('#tab' + currentTab).show();
	if (currentTab == 1) {
		$('#btn-back').hide();
	}
	if (currentTab == tabCount) {
		$('#btn-next').hide();
		$('#printBtn').show();
		$('#printBtnLine').show();
		//$('#printAcceptance').show();
	}
}

function tabNext() {
	currentTab += 1;
	tabInit();
	updatePagination();
	if (currentTab == 4) {
		updateCurrentCalculation();
	}
	if (currentTab == 5) {
		updateResult();
	}
}

function tabBack() {
	currentTab -= 1;
	tabInit();
	updatePagination();
}

function updatePagination() {
	list = "<ul>";
	for (i = 1; i <= tabCount; i++) {
		if (i == currentTab) {
			style = 'class="active"'
		} else {
			style = ' '
		}
		list += '<li id="list' + i + '" ' + style + '>' + i + '</li>';
	}
	list += "</ul>";
	$('#counter').html("");
	$('#counter').append(list);
}

function isEmpty(mixed_var) {
	return (mixed_var == undefined || mixed_var === '' || mixed_var === 0 || mixed_var === '0' || mixed_var === null || mixed_var === false || (isArray(mixed_var) && mixed_var.length === 0));
}
function isArray(mixed_var) {
	return (mixed_var instanceof Array);
}

function myParseFloat(val) {
	var val = val.toString();
	var tmp = val.replace(",", ".");
	var tmp = parseFloat(tmp);
	return tmp.toFixed(1);
}

function ampereRound(val) {
	var result = Math.round(val / 100) * 100;
	return result;
//return val;
}

function updateResult() {
	var totalHeat = operatorpanel["heatemission"];
	var standbycurrent = parseInt($('#standbycurrent').attr('value'));
	var ubextstandby = parseInt($('#ubextstandby').attr('value'));
	var alarmcurrent = parseInt($('#alarmcurrent').attr('value'));
	var ubextalarm = parseInt($('#ubextalarm').attr('value'));
	var emergencycurrenttime = myParseFloat($('#emergencycurrenttime').attr('value'));
	var alarmemergencycurrenttime = myParseFloat($('#alarmemergencycurrenttime').attr('value'));
	var resultTotalTime = myParseFloat(emergencycurrenttime + alarmemergencycurrenttime);
	var resultBatteryPower = myParseFloat((1.25 * ((emergencycurrenttime * (standbycurrent + ubextstandby)) + (alarmemergencycurrenttime * (alarmcurrent + ubextalarm)))) / 10);
	resultBatteryPower = (Math.round(resultBatteryPower) / 100);
	var resultPowerSupplyAmount12 = Math.ceil(resultBatteryPower / 12);
	var resultPowerSupplyAmount24 = Math.ceil(resultBatteryPower / 24);
	var resultPowerAmount = Math.ceil(resultBatteryPower / 48);
	if (resultPowerAmount > 3) {
		resultPowerAmount = 3;
	}
	if (resultBatteryPower > 144) {
		$('#warningResultBatteryPower').show();
	} else {
		$('#warningResultBatteryPower').hide();
	}

	//Calculation for BatteryCurrent

	var resultBatteryAmount = 1;
	var resultCaseAmount = 3;
	for (i = 0; i < cntconfiguration; i++) {
		if (configuration[i]["moduleid"] != -1) {
			totalHeat += parseInt(modules[configuration[i]["moduleid"]]["heatemission"]);
		}
	}
	totalHeat = parseFloat(totalHeat / 100); //Milliwatt zu Watt

	$('#resultStandbyCurrent').html(standbycurrent + ' mA');
	$('#resultStandbyCurrentExt').html(ubextstandby + ' mA');
	$('#resultAlarmCurrent').html(alarmcurrent + ' mA');
	$('#resultAlarmCurrentExt').html(ubextalarm + ' mA');
	$('#resultStandbyTime').html(emergencycurrenttime + ' h');
	$('#resultAlarmTime').html(alarmemergencycurrenttime + ' h');
	$('#resultTotalTime').html(resultTotalTime + ' h');
	$('#resultBatteryPower').html(resultBatteryPower + ' Ah');
//	$('#resultBatteryAmount').html(resultBatteryAmount+' Stück (t.b.d.)');
//	$('#resultPowerSupplyAmount12').html(resultPowerSupplyAmount12+' Stück');
//	$('#resultPowerSupplyAmount24').html(resultPowerSupplyAmount24+' Stück');
	$('#resultPowerAmount').html(resultPowerAmount + ' ' + window.translations[74][window.lang]);
	$('#resultCaseAmount').html(resultCaseAmount + ' ' + window.translations[75][window.lang]);
	$('#resultHeatemission').html(totalHeat + ' W');

	updatePrintResult();

}

function updatePrintResult() {
	/*Description*/
	$('#print_name').html($('#name').val());
	$('#print_objectdescription').html($('#objectdescription').val());
	$('#print_street').html($('#street').val());
	$('#print_zipcity').html($('#zipcity').val());
	$('#print_projectdescription').html($('#projectdescription').val());
	$('#print_projectnote').html($('#projectnote').val());
	$('#print_cabletype').html($('#cabletype :selected').text());
	/*Ringleitungen*/
	$('#print_modules').html("");
	$('#print_modules').append('<tr><td class="first">' + window.translations[72][window.lang] + '</td><td class="first">' + window.translations[73][window.lang] + '</td><td class="first">' + window.translations[25][window.lang] + '</td><td class="first">' + window.translations[69][window.lang] + '</td></tr>');
	for (i = 0; i < cntconfiguration; i++) {
		if (configuration[i]["moduleid"] != -1) {
			var add = '<tr><td>' + modules[configuration[i]["moduleid"]]["name"][lang] + '</td>';
			if (modules[configuration[i]["moduleid"]]["hasloadfactor"]) {
				add += '<td>' + configuration[i]["loadfactor"] + '</td>';
			} else {
				add += '<td>&nbsp;</td>';
			}
			if (configuration[i]["cablelength"] > 0) {
				add += '<td>' + configuration[i]["cablelength"] + '</td>';
			} else {
				add += '<td>&nbsp;</td>';
			}
			if (configuration[i]["alarmarea"] == "yes") {
				add += '<td>ja</td>';
			} else {
				add += '<td>nein</td>';
			}
			add += '</tr>';
			$('#print_modules').append(add);
		}
	}

	/*Results*/
	$('#print_resultStandbyCurrent').html($('#resultStandbyCurrent').html());
	$('#print_resultStandbyCurrentExt').html($('#resultStandbyCurrentExt').html());
	$('#print_resultAlarmCurrent').html($('#resultAlarmCurrent').html());
	$('#print_resultAlarmCurrentExt').html($('#resultAlarmCurrentExt').html());
	$('#print_resultStandbyTime').html($('#resultStandbyTime').html());
	$('#print_resultAlarmTime').html($('#resultAlarmTime').html());
	$('#print_resultTotalTime').html($('#resultTotalTime').html());
	$('#print_resultBatteryPower').html($('#resultBatteryPower').html());
	$('#print_resultPowerAmount').html($('#resultPowerAmount').html());
	$('#print_resultHeatemission').html($('#resultHeatemission').html());
}

function buildDeviceList() {
	for (i = 0; i <= cntdevice; i++) {
		var m = '<div class="devicebox">';
		m += '<img src="products/' + devices[i]["image"] + '" width="60" height="60" alt="' + devices[i]["ordernumber"] + '" />';
		m += '<div><strong>' + devices[i]["ordernumber"] + '</strong><br />';
		m += devices[i]["fullname"][lang] + '<br />';
		if (devices[i]["description"][lang] != "") {
			m += '<small>' + devices[i]["description"][lang] + '</small><br />';
		}
		m += window.translations[29][window.lang] + ': ' + devices[i]["loadfactor"] + '<br />';
		m += '<label class="size2">' + window.translations[71][window.lang] + '</label><input type="text" id="deviceamount' + i + '" class="size3" value="0" onkeyup="checkmax(this,0,255,false); updateLoadfactor();" onblur="checkmax(this,0,255,true);" />';
		m += '</div></div>';
		$('#scrollbox').append(m);
	}
}

function buildModuleSelect() {
	for (i = 0; i <= cntmodules; i++) {
		$('#moduletype').append('<option value="' + i + '">' + modules[i]["name"][lang] + '</option>');
	}
}

function resetSingleConfig(num) {
	configuration[num]["moduleid"] = -1;
	configuration[num]["cablelength"] = 0;
	configuration[num]["alarmarea"] = 0;
	configuration[num]["loadfactor"] = -1;
	configuration[num]["additionalloadfactor"] = 0;
	configuration[num]["editable"] = true;
	configuration[num]["secondmoduleid"] = -1;
	configuration[num]["devicenonautomatic"] = 0;
	configuration[num]["deviceautomatic"] = 0;
	configuration[num]["devices"] = [];
	for (i = 0; i < cntdevice; i++) {
		configuration[num]["devices"][i] = 0;
	}
}

function deleteModuleBox(al) {
	if (confirm(window.translations[70][window.lang])) {
		if (configuration[currentModule]["secondmoduleid"] > -1) {
			resetSingleConfig(configuration[currentModule]["secondmoduleid"]);
		}
		resetSingleConfig(currentModule);
		updateModuleConfiguration();
		closeModuleBox();
	}
}

function updateModuleConfiguration() {
	//Update the visible Part
	var nextadd = false;
	for (i = 0; i < maxModules; i++) {
		mnum = i + 1;
		if (configuration[i]["moduleid"] > -1) {
			$('#moduleslot' + i).addClass('loopboxused');
			var m = '<p><strong>' + modules[configuration[i]["moduleid"]]["name"][lang] + '</strong></p>';
			if (configuration[i]["loadfactor"] > 0) {
				m += '<p>' + window.translations[29][window.lang] + ': ' + configuration[i]["loadfactor"] + '</p>';
			}
			if (parseInt(configuration[i]["cablelength"]) > 0) {
				m += '<p>' + window.translations[25][window.lang] + ': ' + configuration[i]["cablelength"] + '</p>';
			}
			if (configuration[i]["alarmarea"] == "yes") {
				m += '<p class="alarm">' + window.translations[69][window.lang] + '</p>';
			}
			$('#moduleslot' + i + ' .content').html(m);
			$('#moduleslot' + i + ' .link a').html(window.translations[68][window.lang]);
			if (configuration[i]["editable"] == false) {
				$('#moduleslot' + i + ' .link a').hide();
			} else {
				$('#moduleslot' + i + ' .link a').show();
			}
		} else {
			$('#moduleslot' + i).removeClass('loopboxused');
			$('#moduleslot' + i + ' .content').html("");
			$('#moduleslot' + i + ' .link a').show();
			$('#moduleslot' + i + ' .link a').html(window.translations[57][window.lang]);
		}
	}
}

function checkdoubleusage(id) {
	var ret = false;
	if (modules[id]["once"]) {
		for (i = 0; i < cntconfiguration; i++) {
			if (configuration[i]["moduleid"] == id && currentModule != i && configuration[i]["editable"] == true) {
				ret = true;
			}
		}

	}
	return ret;
}

function checkGTmodules(moduletype) {
	var cntgt = 0;
	for (i = 0; i < cntconfiguration; i++) {
		if (configuration[i]["moduleid"] != -1) {
			if (modules[configuration[i]["moduleid"]]["gt"] == false) {
				cntgt++;
			}
		}
	}
	if (cntgt >= maxNoGT && modules[moduletype]["gt"] != true) {
		return true;
	} else {
		return false;
	}
}

function updateModule() {
	var moduleNumber = $('#moduletype').attr("value");
	if (modules[moduleNumber]["hasloadfactor"]) {
		$('#moduleoptions').show();
		$('#scrollbox').show();
		$('#scrollbox').scrollTop(0);
		$('#modulehintbox').hide();
	} else {
		$('#moduleoptions').hide();
		$('#scrollbox').hide();
		$('#modulehintbox').html(window.translations[67][window.lang]);
		$('#modulehintbox').show();
	}
	if (modules[moduleNumber]["devices"]) {
		$('#standarddevice').show();
	} else {
		$('#standarddevice').hide();
	}
}

function initModuleBox() {
	$('#moduletype').val("");
	$('#additionalloadfactor').val("0");
	$('#devicenonautomatic').val("0");
	$('#deviceautomatic').val("0");
	$('#cablelength').val(0);
	$('#maxLoadfactor').html(maxLoadfactor);
	currentLoadfactor = 0;
	$('#currentLoadfactor').html(currentLoadfactor);
	$('#alarmarea').val("no");
	$('#moduleoptions').hide();
	$('#scrollbox').hide();
	$('#modulehintbox').show();
	$('#standarddevice').hide();
	$('#modulehintbox').html(window.translations[66][window.lang]);
	$('#loadfactorWarning').hide();
	for (i = 0; i <= cntdevice; i++) {
		$('#deviceamount' + i).val(0);
	}
	if (configuration[currentModule]["moduleid"] > -1) {
		$('#moduletype').val(configuration[currentModule]["moduleid"]);
		if (isEmpty(configuration[currentModule]["cablelength"])) {
			configuration[currentModule]["cablelength"] = 0;
		}
		$('#devicenonautomatic').val(configuration[currentModule]["devicenonautomatic"]);
		$('#deviceautomatic').val(configuration[currentModule]["deviceautomatic"]);
		$('#cablelength').val(configuration[currentModule]["cablelength"]);
		$('#alarmarea').val(configuration[currentModule]["alarmarea"]);
		currentLoadfactor = configuration[currentModule]["loadfactor"];
		$('#currentLoadfactor').html(currentLoadfactor);
		$('#additionalloadfactor').val(configuration[currentModule]["additionalloadfactor"]);
		if (modules[configuration[currentModule]["moduleid"]]["hasloadfactor"]) {
			for (i = 0; i <= cntdevice; i++) {
				$('#deviceamount' + i).val(configuration[currentModule]["devices"][i]);
			}
		}
		updateModule();
		$('#deletebtn').show();
	} else {
		$('#deletebtn').hide();
	}
	updateMaxLoadfactor();
}

function openModuleBox(num) {
	currentModule = num;
	initModuleBox();
	$('#modulepopup').show();
	$('#scrollbox').scrollTop(0);
}

function closeModuleBox() {
	$('#modulepopup').hide();
	initModuleBox();
}

function updateModuleBox() {
	//Function for updating the setup per Module
	var error = false;

	if ($('#moduletype').attr("value") == -1) {
		alert(window.translations[66][window.lang]);
		error = true;
	}
	if (checkdoubleusage($('#moduletype').attr("value")) == true) {
		alert(window.translations[65][window.lang]);
		error = true;
	}

	if (checkGTmodules($('#moduletype').attr("value")) == true) {
		alert(window.translations[63][window.lang] + maxNoGT + window.translations[64][window.lang]);
		error = true;
	}

	if (currentLoadfactor > maxLoadfactor) {
		if (!confirm(window.translations[58][window.lang])) {
			error = true;
		}
	}

	if (!error) {
		//delete
		if (configuration[currentModule]["secondmoduleid"] > -1) {
			resetSingleConfig(configuration[currentModule]["secondmoduleid"]);
		}
		resetSingleConfig(currentModule);
		//new
		configuration[currentModule]["moduleid"] = $('#moduletype').attr("value");
		configuration[currentModule]["devicenonautomatic"] = $('#devicenonautomatic').attr("value");
		configuration[currentModule]["deviceautomatic"] = $('#deviceautomatic').attr("value");
		if (modules[configuration[currentModule]["moduleid"]]["hasloadfactor"]) {
			configuration[currentModule]["cablelength"] = $('#cablelength').attr("value");
			configuration[currentModule]["alarmarea"] = $('#alarmarea').attr("value");
			configuration[currentModule]["loadfactor"] = currentLoadfactor;
			configuration[currentModule]["additionalloadfactor"] = $('#additionalloadfactor').attr("value");
			for (i = 0; i <= cntdevice; i++) {
				configuration[currentModule]["devices"][i] = $('#deviceamount' + i).attr("value");
			}
		}
		if (modules[configuration[currentModule]["moduleid"]]["size"] == 2) {
			next = -1;
			found = false;
			for (i = 0; i < maxModules; i++) {
				if (configuration[i]["moduleid"] == -1 && found == false) {
					next = i;
					found = true;
				}
			}
			configuration[next] = {};
			configuration[next]["moduleid"] = $('#moduletype').attr("value");
			configuration[next]["editable"] = false;
			configuration[currentModule]["secondmoduleid"] = next;
			if (modules[configuration[currentModule]["moduleid"]]["hasloadfactor"]) {
				configuration[next]["cablelength"] = $('#cablelength').attr("value");
				configuration[next]["alarmarea"] = $('#alarmarea').attr("value");
				configuration[next]["loadfactor"] = currentLoadfactor;

				configuration[next]["devices"] = [];
				for (i = 0; i < cntdevice; i++) {
					c = i + 1;
					configuration[next]["devices"][i] = $('#deviceamount' + c).attr("value");
				}
			}
		}
		updateModuleConfiguration();
		closeModuleBox();
	}
}

function buildModuleDisplayContainer() {
	var c = $('#moduledisplaycontainer');
	for (i = 0; i < maxModules; i++) {
		var m = '<div class="loopbox" id="moduleslot' + i + '">';
		num = i + 1;
		m += '<h5>' + window.translations[56][window.lang] + '</h5><div class="content"></div><p class="link">';
		m += '<a href="javascript:openModuleBox(' + i + ');">';
		m += window.translations[57][window.lang] + '</a></p></div>';
		c.append(m);
	}
}

function updateCabletype() {
	var c = $('#cabletype').val();
	cabletype = c;
}

function updateMaxLoadfactor() {
	var l = $('#cablelength').val();
	var found = false;
	var pointer = cntLoadFactors - 1;
	for (i = 0; i <= cntLoadFactors; i++) {
		if (maxLoadFactors[i]["length"] > l && found == false) {
			pointer = i;
			found = true;
		}
	}
	maxLoadfactor = maxLoadFactors[pointer]["lf" + cabletype];
	$('#maxLoadfactor').html(maxLoadfactor);
	if (maxLoadfactor < currentLoadfactor) {
		$('#loadfactorWarning').show();
	}
}

function updateLoadfactor() {
	var lf = 0;
	for (i = 0; i <= cntdevice; i++) {
		lf += (parseInt(devices[i]["loadfactor"]) * parseInt($('#deviceamount' + i).val()));
	}
	lf += parseInt($('#additionalloadfactor').val());
	currentLoadfactor = lf;
	$('#currentLoadfactor').html(lf);
	if (currentLoadfactor > maxLoadfactor) {
		$('#loadfactorWarning').show();
	} else {
		$('#loadfactorWarning').hide();
	}
}

function init() {
	tabInit();
	updatePagination();
	buildDeviceList();
	buildModuleSelect();
	buildModuleDisplayContainer();
	initModuleBox();
	$('#moduletype').change(function () {
		updateModule();
	});
	$('#cabletype').change(function () {
		updateCabletype();
	});
	$('#cablelength').keyup(function () {
		updateMaxLoadfactor();
	});
	updateCabletype();
	$('#btn-back').addClass("back-" + lang);
	$('#btn-next').addClass("next-" + lang);
	$('#printBtnLine').addClass("printline-" + lang);
	$('#printBtn').addClass("print-" + lang);
	//$('#printAcceptance').addClass("printacceptance-"+lang);

}

function printLineplan() {
	$('#printcontainer').hide();
	$('#linecontainer').show();
	buildlineplan();
	print();
}

function printConfiguration() {
	$('#printcontainer').show();
	$('#linecontainer').hide();
	print();
}

function printAcceptance() {
	window.open('data/Abnahmeprotokoll-798646_102007.pdf');
}

function buildlineplan() {
	var add = '';
	add += '<table width="100%" id="lineplan"><tr class="line3"><td rowspan="55" class="fx">FlexES<br />control</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>';

	for (i = 0; i < cntconfiguration; i++) {
		if (configuration[i]["moduleid"] != -1) {
			if (modules[configuration[i]["moduleid"]]["devices"] == true) {
				var sound = 0;
				var voice = 0;
				var flash = 0;
				for (k = 0; k <= cntdevice; k++) {
					if (configuration[i]["devices"][k] > 0) {
						if (devices[k]["type"] == "sound") {
							sound = parseInt(sound) + parseInt(configuration[i]["devices"][k]);
						}
						if (devices[k]["type"] == "voice") {
							voice = parseInt(voice) + parseInt(configuration[i]["devices"][k]);
						}
						if (devices[k]["type"] == "flash") {
							flash = parseInt(flash) + parseInt(configuration[i]["devices"][k]);
						}
					}
				}
				add += '<tr class="line1 filled"><td rowspan="2" class="name">' + modules[configuration[i]["moduleid"]]["name"][lang] + ' | ' + window.translations[25][window.lang] + ': ' + configuration[i]["cablelength"] + ' | ' + window.translations[73][window.lang] + ': ' + configuration[i]["loadfactor"] + '</td>';
				add += '<td><img src="images/s-dkm.gif" width="15" height="15" /></td>';
				add += '<td><img src="images/s-fd.gif" width="15" height="15" /></td>';
				add += '<td><img src="images/s-fd-sof.gif" width="15" height="15" /></td>';
				add += '<td><img src="images/s-fd-sosp.gif" width="15" height="15" /></td>';
				add += '<td><img src="images/s-light.gif" width="15" height="15" /></td>';
				add += '<td class="last"><img src="images/s-sound.gif" width="15" height="15" /></td></tr>';

				add += '<tr class="line2 filled"><td>' + configuration[i]['devicenonautomatic'] + '</td>';
				add += '<td>' + configuration[i]['deviceautomatic'] + '</td>';
				add += '<td>' + sound + '</td>';
				add += '<td>' + voice + '</td>';
				add += '<td>' + flash + '</td>';
				add += '<td class="last">0</td></tr>';
				add += '<tr class="line3"><td colspan="7">&nbsp;</td></tr>';
			} else {
				add += '<tr class="line1 filled"><td rowspan="2" class="name">' + modules[configuration[i]["moduleid"]]["name"][lang] + '</td>';
				add += '<td colspan="6" class="last">&nbsp;</td></tr>';
				add += '<tr class="line2 filled"><td colspan="6" class="last">&nbsp;</td></tr>';
				add += '<tr class="line3"><td colspan="7">&nbsp;</td></tr>';
			}

		} else {
			add += '<tr class="line1"><td rowspan="2" colspan="7" class="name">&nbsp;</td></tr>';
			add += '<tr class="line2"><td colspan="7">&nbsp;</td></tr>';
			add += '<tr class="line3"><td colspan="7">&nbsp;</td></tr>';
		}

	}
	add += '</table>';
	$('#stranglist').html(add);
}

//Translation Output
function p(i) {
	r = window.translations[i][window.lang];
	if (r == "xxx") {
		document.write("Missing" + i);
	} else {
		document.write(r);
	}
}
